# HIFSuite demo: generated C++ and SystemC (RTL) virtual-platforms
--------------------------------------------------------------------------------

This is a preview of the complete HIFSuite demo to be released in 2019. It
is based on the COM6502 case study: a heterogeneous virtual-platform built-up
from a set of models expressed in different languages. This release of the demo
shows the initial heterogeneous models of the components, and the generated
homogeneous virtual-platform in SystemC and C++.
The homogeneous virtual-platforms generated provided in this demo are fully able
to emulate the behavior of software compiled for the MOS6502 CPU: the CPU
equipping the modelled hardware platform.
To obtain a complete release of HIFSuite, please contact EDALab S.r.l and refer 
to the official website of [HIFSuite](https://www.hifsuite.com).

## Requirements
--------------------------------------------------------------------------------
In order to execute the virtual-platforms contained in this demo, the following
third-party software is required:
- **Accellera SystemC 2.3.2**
- **CC65 Compiler** available on [GitHub](https://github.com/cc65/cc65)
	- the compiler must be downloaded and compiled following the instructions 
        available in the Readme file provided in the repository. Then, it is 
        necessary to export an environment variable named CC65_DIR set to the path 
        to the main directory where the compiled has been compiled 
	    e.g., if the git repository has been cloned in */home/user/cc65/*, the user must: 
	    *> export CC65_DIR=/home/user/cc65*
- **GNU GCC 7+**, or any compiler supporting C++17 standard.
- **GNU Make** 
- **CMake 2.6+** 

## Directories organization
--------------------------------------------------------------------------------
The demo displays all the files used within the HIFSuite-based integration flow.
It shows the original description files of the components of the platform, and 
the files generated by using the set of tools released within the HIFSuite. It 
also shows the execution of an example software on top of the virtual platforms 
generated by exploiting the integration flow. The demo is organized in the 
following directories:

- **application/**: it contains the source code of an example of C application 
    (within the *vanilla*/ sub-directory) that can be run on the platform's CPU.
- **components/**: it contains a sub-directory for each sub-component of the 
    platform. For each component, it contains its *VHDL or Verilog* description,
    its *hif.xml* representation, the automatically generated *C++* and *SystemC*
    equivalent models.
- **ipxact/**: it contains the IP-XACT[^1] description of the components.
- **simulation/**: it contains the integrated virtual-platforms generated by
    translating, abstracting, and integrating the models in the *components/* 
    directory. It contains two sub-directories: *cpp* and *systemc* containing 
    respectively the C++ and SystemC homogeneous virtual-platform.


## The COM6502 Platform
--------------------------------------------------------------------------------
COM6502 test-case is a hardware platform based on the MOS6502 CPU. The platform
comprehend a RAM unit, and a ROM storing the software. A model of AMBA APB Bus
is used to connect a set of both digital and analog peripherals. Furthermore,
the device provide a network interface to allow external communication. The
components involved in the platform are described hereby.

### Accelerometer
A 3-axis accelerometer written in Verilog-AMS. It comes with a wrapper, used to
connect it with the APB Slave Interface.

### AMBA APB Bus
APB is designed for low bandwidth control accesses, for example register 
interfaces on system peripherals. This bus has an address and data phase similar
to AHB, but with a low complexity signal list.

### Memory
A simple memory, specifically designed for the mos 6502 addressing.

### MOS 6502
Is an 8-bit microprocessor.

```
Max. CPU clock    1 MHz to 3 MHz
Instruction set   MOS 6502
Transistors       3510  to 4237
Instructions      56
Data width        8
Address width     16
```

### Mulitplier
A simple integer multiplier. It comes with a wrapper, used to connect it with
the APB Slave Interface.

### Network Interface
A simple network interface which allows to send and receive data from network.
In this particular case it could be connected to a network simulator,
e.g., Scnsl. It comes with a wrapper, used to connect it with the APB Slave
Interface.

### Watchdog
A simple up-counter which also checks if the counter exceeds a given value.


## Demo usage: overview
--------------------------------------------------------------------------------
In order to appreciate the potential of the homogeneous virtual-platforms generated
by HIFSuite requires two steps:

1. (eventually customize,) compile and deploy the software application. The exact
actions to perform are described in the *Software Application* section of
this document.
2. Build the virtual-platforms, as described in the following of this document.


## Software Application
--------------------------------------------------------------------------------
The software application stored in the *application/vanilla* directory is a 
minimal operating system managing the platform, and performing the testing of the
different peripherals available in the hardware platform.
Once being compiled, the software application binary is dumped into a text file
(i.e., *rom.mem*). Then, the virtual-platforms load such binary image into the
ROM unit of the platform by reading the text file during the initialization
phase of the virtual-platform execution.

### Compilation and deployment
A Makefile is available in the *application/vanilla* directory. It requires the
environment variable CC65_DIR to be properly set (as described above).
The commands necessary to compile the software are the following:

```
> make
```

to compile the source code in the *application/vanilla/src* directory; it generates 
the file *application/vanilla/bin/roms.mem*: a text file containing the binary 
representation of the compiled executable for the m6502 CPU.

```
> make deploy
```

to copy the generated *application/vanilla/bin/roms.mem* into the *roms* directories
of the C++ and SystemC virtual platforms.

### Customization
The application provides different *#define TEST_* entries in the 
*application/vanilla/src/main.c* file. Each entry enables the test
of a different peripheral[^2].


## Building the virtual-platforms
--------------------------------------------------------------------------------
The demo provides two different homogeneous virtual-platform, one expressed in
SystemC, while the other is expressed in C++. Both platforms requires that the
software application has been compiled and deployed (as presented above).

### Building the SystemC virtual-platform

The main directory of the SystemC virtual-platform is *simulation/systemc*. Move
to the main directory:

```
> cd simulation/systemc
```

It contains the following directories: 
- *build*: the working directory for the compilation;
- *inc* and *src*: contains the source code of the platform generated by HIFSuite.
- *roms*: contains the text files providing the binary representation of the
    software applications to be executed. In particular, it contains the file
    *rom.mem* generated above after the application compilation and deployment.
It also contains the CMakeList.txt file.

Make sure that SystemC header and includes are visible to the compiler and the
linker. If they are not visible you may:
    - export new values for the CPLUS_INCLUDE_PATH and LD_LIBRARY_PATH environment
    variables to make the SystemC include and libraries visible to the compiler;
    - modify the CMakeList.txt file to adapt it to your SystemC installation.

For example, if you SystemC is installed in */home/user/third_party/systemc*

```
> export CPLUS_INCLUDE_PATH=$CPLUS_INCLUDE_PATH:/home/user/third_party/systemc/include
> export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/home/user/third_party/systemc/lib
```

Move to the build directory, configure and compile:

```
> cd build
> cmake ..
> make
```

It generates the m6502 executable, that you can run by typing:

```
> ./m6502
```


### Building the C++ virtual-platform

The main directory of the C++ virtual-platform is *simulation/cpp*. Move
to the main directory:

```
> cd simulation/cpp
```

It contains the following directories: 
- *build*: the working directory for the compilation;
- *inc* and *src*: contains the source code of the platform generated by HIFSuite.
- *roms*: contains the text files providing the binary representation of the
software applications to be executed. In particular, it contains the file
*rom.mem* generated above after the application compilation and deployment.

It also contains the CMakeList.txt file.

The C++ virtual-platform does not have any external dependency, being completely
written in plain standard C++. Thus, you may just compile the virtual-platform
by moving to the build directory, configure and compile:

```
> cd build
> cmake ..
> make
```

It generates the m6502 executable, that you can run by typing:

```
> ./m6502
```

--------------------------------------------------------------------------------
## Support
To receive support write to: 
- michele.lora@univr.it or
- enrico.fraccaroli@univr.it
--------------------------------------------------------------------------------



[^1]: the IP-XACT supported by HIFSuite is the IEEE 1685-2009 Standard. The novel
IEEE 1685-2014 standard will be supported by the following releases of HIFSuite.
[^2]: *#define TEST_NETWORK* requires to be plugged to [SCNSL](https://sourceforge.net/projects/scnsl/)
in order to receive packets over a simulated network.